#include "prjlibs-c/standards.h"
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <stdlib.h>

#include <skalibs/stddjb.h>
#include "prjlibs-c/constants.h"
#include "prjlibs-c/diewarn.h"
#include "prjlibs-c/types.h"
#include "prjlibs-c/warn.h"
#include "prjlibs-c/intattr.h"
#include "drop_root.h"

#define var_gid "$GID"
#define var_uid "$UID"

void drop_root(void) {
  char const* s;
  uint64 x;
  type_len i;

  s=getenv("ROOT");
  if (s!=NULLP) {
    if (chdir(s)!=0) DIE1(chdir, s);
    if (chroot(".")!=0) DIE1(chroot, s);
  }

  s=getenv(var_gid+1);
  if (s!=NULLP) {
    gid_t g;
    i=uint64_scan(s, &x);
    if (i==0 || s[i]!='\0') DIE_MALFORMED(var_gid, s);
    g=x;
    if (INTATTR_NEGATIVE(gid_t, g) || (uint64)g!=x) DIE_OVERFLOW();
    if (setgid(g)!=0) DIE0(setgid);
  }

  s=getenv(var_uid+1);
  if (s!=NULLP) {
    uid_t u;
    i=uint64_scan(s, &x);
    if (i==0 || s[i]!='\0') DIE_MALFORMED(var_uid, s);
    u=x;
    if (INTATTR_NEGATIVE(uid_t, u) || (uint64)u!=x) DIE_OVERFLOW();
    if (setuid(u)!=0) DIE0(setuid);
  }
}
