
void imap_cmd_SELECT(void) {
  type_uid_buf buf_uid;
  DIR* dir;
  type_uid n_msgs=0;
  state=state_authenticated;
  uil_empty(&msgs_all);
  mb_selected=do_mailbox_prep();
  END_ARGS();
  if (mb_selected==NULLP) return;
  VEC_TRUNC(char, &path, 0);
  must_n(&path, mb_selected->name, mb_selected->name_len);
  must_a(&path, subdir_uidinfo, 0);
  dir=opendir(s(&path));
  if (dir==NULLP) { RESPOND_NO_1("unable to open mailbox"); return; }
  for (;;) {
    type_len uidlen;
    type_uid uid;
    struct dirent* de=(errno=0, readdir(dir));
    if (de==NULLP) {
      if (errno==0) break;
      WARN1(read, s(&path));
      RESPOND_NO_1("unable to read mailbox");
      return;
    }
    uidlen=scan_uid(de->d_name, &uid);
    if (uidlen==0 || de->d_name[uidlen]!='\0') continue;
    if (uil_add(&msgs_all, uid)!=0) DIE0(alloc);
    ++n_msgs;
    if (n_msgs==0) DIE_OVERFLOW();
  }
  closedir(dir);
  uil_empty(&msgs_Answered);
  uil_empty(&msgs_Flagged);
  uil_empty(&msgs_Deleted);
  uil_empty(&msgs_Draft);
  uil_empty(&msgs_Recent);
  uil_empty(&msgs_Seen);
  if (VEC_PUSHN(type_uid, &msgs_Seen, VEC_ELTS(type_uid, &msgs_all),
                VEC_LEN(type_uid, &msgs_all))!=0)
    DIE0(alloc);
  FMT0(type_uid, &buf_uid, n_msgs);
  RESPOND_NOTAG_2(buf_uid, " EXISTS");
  RESPOND_NOTAG_1("0 RECENT");
  RESPOND_NOTAG_1("FLAGS (\\Seen \\Answered \\Flagged \\Deleted \\Draft)");
  {
    type_uid next=next_uid(mb_selected->name, mb_selected->name_len);
    if (next!=0) {
      FMT0(type_uid, &buf_uid, next);
      RESPOND_NOTAG_3("OK [UIDNEXT ", buf_uid, "] ok");
    }
  }
  RESPOND_NOTAG_1("OK [UIDVALIDITY 1] ok"); 
  RESPOND_NOTAG_1("OK [PERMANENTFLAGS ()] ok");
  RESPOND_OK_1("[READ_ONLY]");
  state=state_selected;
}
