
void imap_cmd_STATUS(void) {
  type_uid_buf buf_uid;
  type_bool flag_recent=0, flag_unseen=0, flag_uidvalidity=0, flag_uidnext=0,
    flag_messages=0;
  char osep[]=" (";
  mailbox_t const* mb=do_mailbox_prep();
  if (mb==NULLP) return;
  if (!consumea(" (")) REJECT();
  buffer_unget(buffer_0, 1);
  b0peek[0]=' ';
  for (;;) {
    if (!consumec(' ')) REJECT();
    if (consumec(')')) break;
#define CASE(x) else if (consumea(#x)) flag_##x=1
    CASE(recent);
    CASE(unseen);
    CASE(uidnext);
    CASE(uidvalidity);
    CASE(messages);
#undef CASE
    else REJECT();
  }
  END_ARGS();
  mustwrite("* STATUS ");
  mustwrite(mb->name);
  if (flag_recent)      writepart(osep, "RECENT 0", "");
  if (flag_uidvalidity) writepart(osep, "UIDVALIDITY 1", ""); 
  if (flag_unseen) {
    type_uid n_unseen=0;
    type_uil_iter iter;
    for (uil_iter_init(&iter, &msgs_all); uil_iter_next(&iter);)
      if (!uil_member(&msgs_Seen, iter.elt)) {
        ++n_unseen;
        if (n_unseen==0) DIE_OVERFLOW();
      }
    FMT0(type_uid, &buf_uid, n_unseen);
    writepart(osep, "UNSEEN ", buf_uid);
  }
  if (flag_uidnext) {
    type_uid next=next_uid(mb->name, mb->name_len);
    if (next!=0) {
      FMT0(type_uid, &buf_uid, next);
      writepart(osep, "UIDNEXT ", buf_uid);
    }
  }
  if (flag_messages) {
    DIR* dir;
    type_uid n_msgs=0;
    VEC_TRUNC(char, &path, 0);
    must_n(&path, mb->name, mb->name_len);
    must_1(&path, '/');
    must_a(&path, subdir_uidinfo, 0);
    dir=opendir(s(&path));
    if (dir==NULLP) {
      WARN1(open, s(&path));
      RESPOND_NO_1("unable to open mailbox");
      return;
    }
    for (;;) {
      type_uid uid;
      type_len uid_len;
      struct dirent* de=(errno=0, readdir(dir));
      if (de==NULLP) {
        if (errno==0) break;
        WARN1(read, s(&path));
        closedir(dir);
        RESPOND_NO_1("unable to read mailbox");
        return;
      }
      uid_len=scan_uid(de->d_name, &uid);
      if (uid_len==0 || de->d_name[uid_len]!='\0') continue;
      ++n_msgs;
      if (n_msgs==0) DIE_OVERFLOW();
    }
    closedir(dir);
    FMT0(type_uid, &buf_uid, n_msgs);
    writepart(osep, "MESSAGES ", buf_uid);
  }
  respond(")", NULLP, NULLP, NULLP, NULLP, NULLP);
  RESPOND_OK_0();
}
